# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class Event(BaseModel):
    """
    Event
    """ # noqa: E501
    operation: StrictStr
    path: StrictStr
    target_path: Optional[StrictStr] = None
    metadata: Optional[List[Annotated[Tuple[StrictStr, StrictStr, Union[Dict,List]], Field(min_length=3, max_length=3)]]] = None
    ticket: Optional[StrictStr] = None
    profile_tags: Optional[Dict[str, StrictStr]] = None
    __properties: ClassVar[List[str]] = ["operation", "path", "target_path", "metadata", "ticket", "profile_tags"]

    @field_validator('operation')
    def operation_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['upload', 'download', 'share', 'request']):
            raise ValueError("must be one of enum values ('upload', 'download', 'share', 'request')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Event from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if target_path (nullable) is None
        # and model_fields_set contains the field
        if self.target_path is None and "target_path" in self.model_fields_set:
            _dict['target_path'] = None

        # set to None if ticket (nullable) is None
        # and model_fields_set contains the field
        if self.ticket is None and "ticket" in self.model_fields_set:
            _dict['ticket'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Event from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "operation": obj.get("operation"),
            "path": obj.get("path"),
            "target_path": obj.get("target_path"),
            "metadata": obj.get("metadata"),
            "ticket": obj.get("ticket"),
            "profile_tags": obj.get("profile_tags")
        })
        return _obj


